VERSION 4.00
Begin VB.MDIForm MDIForm1 
   BackColor       =   &H8000000C&
   Caption         =   "Mdibackg sample from BlackBeltVB.com"
   ClientHeight    =   8010
   ClientLeft      =   1635
   ClientTop       =   1830
   ClientWidth     =   5970
   Height          =   8700
   Left            =   1575
   LinkTopic       =   "MDIForm1"
   Top             =   1200
   Width           =   6090
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   2400
      Top             =   3780
   End
   Begin VB.PictureBox picHolder 
      Align           =   1  'Align Top
      BorderStyle     =   0  'None
      Height          =   3375
      Left            =   0
      ScaleHeight     =   3375
      ScaleWidth      =   5970
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   5970
      Begin VB.PictureBox picWork 
         BorderStyle     =   0  'None
         Height          =   3015
         Left            =   540
         Picture         =   "mdibackg.frx":0000
         ScaleHeight     =   3015
         ScaleWidth      =   4095
         TabIndex        =   1
         Top             =   0
         Width           =   4095
      End
   End
   Begin VB.Menu mnuBack 
      Caption         =   "&Background"
      Begin VB.Menu mnuCenter 
         Caption         =   "&Center"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuTile 
         Caption         =   "&Tile"
      End
   End
End
Attribute VB_Name = "MDIForm1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Mdibackg sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
'
' This software is FREEWARE. You may use it as you see fit for
' your own projects but you may not re-sell the original or the
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/mdibackg.htm"
'
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' 2-3-00
' Added a timer so that the resizing won't occur until 100ms
' after the sizing is finished. This is needed in an NT executable,
' which resizes asynchronously.
'
' This sample shows how to tile or center a background on
' an MDI form. It is a bit trickier than on a standard
' form since an MDI doesn't have the PaintPicture method
' or an hDC to paint images onto.
'
' A memory DC (hMemDC) is used to store the original picture
' that will be centered or tiled. The MDI Form itself has
' two invisible controls - picHolder and picWork. picHolder
' is on the MDI form and picWork is on the picHolder control.
' This is needed because an MDI uses the Align property, forcing
' any control directly on the MDI to match the width of the MDI.
'
' Note also that I first load the picture into the picWork control.
' This is because the StdPicture object doesn't "inherit" the proper
' width and height of its bitmap, but picWork can automatically size
' itself to the bitmap. You can go the long way of using API calls
' to determine the bitmap dimensions, but using picWork and its
' AutoSize property is easier.
'
' The drawing is done in the Resize event. I draw from the memory DC
' to the picWork control. Note that picWork is sized to match the
' client area of the MDI form, and its background color is set to
' match that of the MDI. Once the image is drawn onto the MDI,
' I set the Picture property of the MDI to the drawn image.

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal lDC As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal lDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal lDC As Long, ByVal hObject As Long) As Long

Dim pic As StdPicture, hMemDC As Long, pHeight As Long, pWidth As Long

Private Sub MDIForm_Load()
    picHolder.Visible = False
    picWork.Visible = False
    picWork.AutoRedraw = True
    picWork.AutoSize = True
    ' I placed this picture directly into the picWork object
    'picWork.Picture = LoadPicture("c:\winnt\internet explorer wallpaper.bmp")
    pHeight = picWork.Height
    pWidth = picWork.Width
    Set pic = picWork.Picture
    Set picWork.Picture = Nothing
    picWork.AutoSize = False
    
    hMemDC = CreateCompatibleDC(picWork.hDC)
    SelectObject hMemDC, pic.Handle
End Sub

Private Sub MDIForm_Resize()
    Timer1.Enabled = False
    Timer1.Enabled = True
End Sub

Private Sub MDIForm_Unload(Cancel As Integer)
    Set pic = Nothing
    DeleteDC hMemDC
End Sub

Private Sub mnuCenter_Click()
    mnuTile.Checked = False
    mnuCenter.Checked = True
    MDIForm_Resize
End Sub

Private Sub mnuTile_Click()
    mnuTile.Checked = True
    mnuCenter.Checked = False
    MDIForm_Resize
End Sub

Private Sub Timer1_Timer()
    Timer1.Enabled = False
    If WindowState <> vbMinimized Then
        Dim X As Long, Y As Long
        picWork.BackColor = BackColor
        picWork.Move 0, 0, ScaleWidth, ScaleHeight
        If mnuTile.Checked Then
            For X = 0 To ScaleWidth Step pWidth
                For Y = 0 To ScaleHeight Step pHeight
                    BitBlt picWork.hDC, X \ Screen.TwipsPerPixelX, Y \ Screen.TwipsPerPixelX, pWidth \ Screen.TwipsPerPixelX, pHeight \ Screen.TwipsPerPixelY, hMemDC, 0, 0, vbSrcCopy
                Next
            Next
        Else
            X = (ScaleWidth - pWidth) \ 2: X = X \ Screen.TwipsPerPixelX
            Y = (ScaleHeight - pHeight) \ 2: Y = Y \ Screen.TwipsPerPixelY
            BitBlt picWork.hDC, X, Y, pWidth \ Screen.TwipsPerPixelX, pHeight \ Screen.TwipsPerPixelY, hMemDC, 0, 0, vbSrcCopy
        End If
        Set Picture = picWork.Image
        Visible = False
        Visible = True
    End If
End Sub
